# formide-cli
With this package you can create and publish apps for the Formide 3D printing platform using this command line tool.

## Installation
```
npm install -g formide-cli
```

If you don't have node.js and npm installed yet, please check out the node.js website at [nodejs.org](http://nodejs.org).

## Usage

#### Login
Login to FORMIDE with your account to publish apps.
```
formide login
```

#### Init
**Run in parent folder**

Create a new empty app or choose a (folder) name and template during the init process.
```
formide init
```

#### Run
**Run in app folder**

Run your app locally before publishing to the Formide App Store.
```
formide run
```

#### Publish
**Run in app folder**

Publish your app to the Formide App Store (first, it will appear in the dev center where you must publish an uploaded version).
```
formide publish
```

#### Bump
**Run in app folder**

Bump the app version in app.json automatically. Accepts `patch`, `minor` and `major` as level argument. Defaults to `patch`.
```
formide bump [level]
```

#### Info
**Run in app folder**

Get info about the app in the current folder.
```
formide info
```

#### Me
Get info about the logged in user.
```
formide me
```

#### Help
List all command line arguments.
```
formide --help
```
