'use strict';

process.env.NODE_TLS_REJECT_UNAUTHORIZED = "0"; // ugly hack!

const request = require('request');
const _		  = require('underscore');
const apiRoot = 'https://api.formide.com';
// const apiRoot = 'http://localhost:3000';
const fs	  = require('fs');

var call = function(options, callback) {

	// create the options object with defaults
	options = _.extend({
		path			: '/',
		method			: 'GET',
		access_token	: lib.settings.accessToken,
		// refresh_token	: lib.settings.refreshToken,
		json			: true,
		appUpload		: false
	}, options);

	// make the request
	var r = request({
		method	: options.method,
		url		: apiRoot + options.path,
		json	: options.json,
		headers	: {
			'Authorization': 'Bearer ' + options.access_token
		}
	}, function(err, response, body) {
		if (err) return callback(err);
		if (typeof callback == 'function') {
			callback(null, response, body);
		}
	});

	// when app is uploaded, add upload multipart form
	if(options.appUpload) {
		var form = r.form();
		form.append('version', options.appUpload.version);
		form.append('file', fs.createReadStream(options.appUpload.zipPath, { filename: 'app.zip', contentType: 'application/zip' }));
	}
};

module.exports.call = call;
