'use strict';

const path		= require('path');
const express	= require('express');
const open		= require('open');
const loginPath = 'https://developers.formide.com/#/login?cli=true';
// const loginPath = 'http://localhost:8081/#/login?cli=true';

var login = function(callback) {

	// express server
	var app = express();

	// cross domain headers
	app.use(function(req, res, next) {
		res.header("Access-Control-Allow-Origin", "*");
		next();
	});

	// catch login post message
	app.get('/login', function(req, res) {

		// set access token and refresh token
		lib.settings.accessToken = req.query.accessToken;
		// lib.settings.refreshToken = req.query.refreshToken;

		// get user info
		lib.api.call({
			path: '/me'
		}, function(err, result, body){
			if (err) throw(err);

			// save user info
			lib.settings.user = body;

			// send OK to browser
			res.send('Hi ' + body.username + '. You are successfully logged in. You can now close this window.');

			// show name in console
			console.log(('Welcome, ' + body.username + '! You are now logged in to the Formide CLI.').green);

			// callback
			if (typeof callback == 'function') {
				callback();
			}
			else {
				setTimeout(process.exit, 1000);
			}
		});
	});

	// listen to port
	app.listen(8000);

	// open local login page in browser
	console.log("Opening auth page at " + loginPath);
	open(loginPath);
};

var me = function() {
	console.log(columnify(lib.settings.user, {
		showHeaders: false
	}));
};

var logout = function() {
	delete lib.settings.accessToken;
	delete lib.settings.refreshToken;
	delete lib.settings.user;
	setTimeout(process.exit, 1000);
};

module.exports.login = login;
module.exports.logout = logout;
module.exports.me = me;
